/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Fast.xs. Do not edit this file, edit Fast.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Filesys/DiskUsage/Fast.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <stdio.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>

#define PACKAGE_NAME  "Filesys::DiskUsage::Fast"

static char current_dir[MAXPATHLEN] = ".";
static char parent_dir[MAXPATHLEN] = "..";

static unsigned long long total = 0;
unsigned int debug = 0;
unsigned int show_warnings = 1;
unsigned int sector_size = 0;

unsigned long long get_file_size( char *filename ){
	struct stat stat_buf;
	char cwd[MAXPATHLEN];
	unsigned long long result;
	
	if( lstat( filename, &stat_buf ) == 0 ){
		// ok
		if( S_ISLNK( stat_buf.st_mode ) ){
			return 0;
		}
		else{
			if( sector_size > 1 ){
				// sector
				result = sector_size - 1 + (unsigned long long)stat_buf.st_size;
				result -= result % sector_size;
				
				return result;
			}
			else{
				// real
				return (unsigned long long)stat_buf.st_size;
			}
		}
	}
	else{
		// not ok
		if( show_warnings ){
			memset( cwd, '\0', MAXPATHLEN );
			getcwd( cwd, MAXPATHLEN );
			warn( "could not read file %s%s (%s)", cwd, filename, strerror( errno ) );
		}
		return 0;
	}
}

void get_dir_size( char *dirname ){
	DIR *dir;
	struct dirent *dp;
	char newfile[MAXPATHLEN];
	unsigned long long count = 0;
	char cwd[MAXPATHLEN];
#if defined (__SVR4) && defined (__sun)
	struct stat s;
#endif
	
	// open dir
	if( ( dir = opendir( dirname ) ) == NULL ){
		if( show_warnings ){
			memset( cwd, '\0', MAXPATHLEN ); 
			getcwd( cwd, MAXPATHLEN );
			warn( "could not open dir  %s%s (%s)", cwd, dirname, strerror( errno ) );
		}
		return;
	}
	
	if( chdir( dirname ) == -1 ){
		if( show_warnings )
			warn( "could not chdir     %s (%s)", dirname, strerror( errno ) );
		return;
	}
	
	for( dp = readdir( dir ); dp != NULL; dp = readdir( dir ) ){
#if defined (__SVR4) && defined (__sun)
		stat( dp->d_name, &s );
		if( S_ISDIR( s.st_mode ) ){
#else
		if( dp->d_type == DT_DIR ){
#endif
			// dir
			
			// omit . and ..
			if( strcmp( dp->d_name, current_dir ) == 0 || strcmp( dp->d_name, parent_dir ) == 0 ){
				continue;
			}
			
			get_dir_size( dp->d_name );
		}
		else{
			// file (or fifo, symlink etc.)
			count = get_file_size( dp->d_name );
			
			if( debug )
				fprintf( stderr, "%s: %lld\n", dp->d_name, count );
			
			total += count;
		}
	}
	closedir( dir );
	
	free( dp );
	
	if( chdir("..") == -1 ){
		if( show_warnings )
			warn( "could not chdir to  %s (%s)", "..", strerror( errno ) );
		return;
	}
}

#line 132 "lib/Filesys/DiskUsage/Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 276 "lib/Filesys/DiskUsage/Fast.c"

XS_EUPXS(XS_Filesys__DiskUsage__Fast_du); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Filesys__DiskUsage__Fast_du)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	UV	RETVAL;
	dXSTARG;
#line 130 "lib/Filesys/DiskUsage/Fast.xs"
		int index;
		char *filepath;
		struct stat stat_buf;
		// char string[25];
		// STRLEN length;

		if( ! items ){
			// RETVAL = SvUV( newSVpv("0", 1) );
			RETVAL = PTR2UV(0);
		}
		else{
			total = 0;
			debug = SvTRUE(GvSV(gv_fetchpv(form("%s::Debug", PACKAGE_NAME), TRUE, SVt_PV))) ? 1 : 0;
			show_warnings = SvTRUE(GvSV(gv_fetchpv(form("%s::ShowWarnings", PACKAGE_NAME), TRUE, SVt_PV))) ? 1 : 0;
			sector_size = SvUV(GvSV(gv_fetchpv(form("%s::SectorSize", PACKAGE_NAME), TRUE, SVt_PV)));

			for( index = 0 ; index < items ; index++ ){
				SV *stacksv = ST(index);
				filepath = SvPV_nolen(stacksv);

				if( stat( filepath, &stat_buf ) == 0 ){
					if( S_ISDIR( stat_buf.st_mode ) ){
						get_dir_size( filepath );
					}
					// else if( S_ISLNK( stat_buf.st_mode ) ){
					// 	;
					// }
					else{
						total += get_file_size( filepath );
					}
				}
			}

			// see: http://groups.google.com/group/perl.xs/browse_thread/thread/27e7881105eb4329
			// length = sprintf(string, "%llu", total);
			// RETVAL = SvUV( newSVpv(string, length) );
			RETVAL = PTR2UV(total);
		}
#line 326 "lib/Filesys/DiskUsage/Fast.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Filesys__DiskUsage__Fast); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Filesys__DiskUsage__Fast)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Filesys::DiskUsage::Fast::du", XS_Filesys__DiskUsage__Fast_du, file, "@");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

